<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Delete ServiceType
 * @subpackage Services
 */
class Delete extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named DeleteKategori
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteKategori $parameters
     * @return \StructType\DeleteKategoriResponse|bool
     */
    public function DeleteKategori(\StructType\DeleteKategori $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->DeleteKategori($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteMarka
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteMarka $parameters
     * @return \StructType\DeleteMarkaResponse|bool
     */
    public function DeleteMarka(\StructType\DeleteMarka $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->DeleteMarka($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteTedarikci
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteTedarikci $parameters
     * @return \StructType\DeleteTedarikciResponse|bool
     */
    public function DeleteTedarikci(\StructType\DeleteTedarikci $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->DeleteTedarikci($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteUrunKategori
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteUrunKategori $parameters
     * @return \StructType\DeleteUrunKategoriResponse|bool
     */
    public function DeleteUrunKategori(\StructType\DeleteUrunKategori $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->DeleteUrunKategori($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteUrunEtiket
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteUrunEtiket $parameters
     * @return \StructType\DeleteUrunEtiketResponse|bool
     */
    public function DeleteUrunEtiket(\StructType\DeleteUrunEtiket $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->DeleteUrunEtiket($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteIlgiliUrun
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteIlgiliUrun $parameters
     * @return \StructType\DeleteIlgiliUrunResponse|bool
     */
    public function DeleteIlgiliUrun(\StructType\DeleteIlgiliUrun $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->DeleteIlgiliUrun($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\DeleteIlgiliUrunResponse|\StructType\DeleteKategoriResponse|\StructType\DeleteMarkaResponse|\StructType\DeleteTedarikciResponse|\StructType\DeleteUrunEtiketResponse|\StructType\DeleteUrunKategoriResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
