<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Urun ServiceType
 * @subpackage Services
 */
class Urun extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named UrunResimYukle
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\UrunResimYukle $parameters
     * @return \StructType\UrunResimYukleResponse|bool
     */
    public function UrunResimYukle(\StructType\UrunResimYukle $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->UrunResimYukle($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UrunBarkodGuncelle
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\UrunBarkodGuncelle $parameters
     * @return \StructType\UrunBarkodGuncelleResponse|bool
     */
    public function UrunBarkodGuncelle(\StructType\UrunBarkodGuncelle $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->UrunBarkodGuncelle($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\UrunBarkodGuncelleResponse|\StructType\UrunResimYukleResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
