<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveUrun StructType
 * @subpackage Structs
 */
class SaveUrun extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The urunKartlari
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfUrunKarti
     */
    public $urunKartlari;
    /**
     * The ukAyar
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunKartiAyar
     */
    public $ukAyar;
    /**
     * The vAyar
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VaryasyonAyar
     */
    public $vAyar;
    /**
     * Constructor method for SaveUrun
     * @uses SaveUrun::setUyeKodu()
     * @uses SaveUrun::setUrunKartlari()
     * @uses SaveUrun::setUkAyar()
     * @uses SaveUrun::setVAyar()
     * @param string $uyeKodu
     * @param \ArrayType\ArrayOfUrunKarti $urunKartlari
     * @param \StructType\UrunKartiAyar $ukAyar
     * @param \StructType\VaryasyonAyar $vAyar
     */
    public function __construct($uyeKodu = null, \ArrayType\ArrayOfUrunKarti $urunKartlari = null, \StructType\UrunKartiAyar $ukAyar = null, \StructType\VaryasyonAyar $vAyar = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setUrunKartlari($urunKartlari)
            ->setUkAyar($ukAyar)
            ->setVAyar($vAyar);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SaveUrun
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get urunKartlari value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfUrunKarti|null
     */
    public function getUrunKartlari()
    {
        return isset($this->urunKartlari) ? $this->urunKartlari : null;
    }
    /**
     * Set urunKartlari value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfUrunKarti $urunKartlari
     * @return \StructType\SaveUrun
     */
    public function setUrunKartlari(\ArrayType\ArrayOfUrunKarti $urunKartlari = null)
    {
        if (is_null($urunKartlari) || (is_array($urunKartlari) && empty($urunKartlari))) {
            unset($this->urunKartlari);
        } else {
            $this->urunKartlari = $urunKartlari;
        }
        return $this;
    }
    /**
     * Get ukAyar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunKartiAyar|null
     */
    public function getUkAyar()
    {
        return isset($this->ukAyar) ? $this->ukAyar : null;
    }
    /**
     * Set ukAyar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UrunKartiAyar $ukAyar
     * @return \StructType\SaveUrun
     */
    public function setUkAyar(\StructType\UrunKartiAyar $ukAyar = null)
    {
        if (is_null($ukAyar) || (is_array($ukAyar) && empty($ukAyar))) {
            unset($this->ukAyar);
        } else {
            $this->ukAyar = $ukAyar;
        }
        return $this;
    }
    /**
     * Get vAyar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VaryasyonAyar|null
     */
    public function getVAyar()
    {
        return isset($this->vAyar) ? $this->vAyar : null;
    }
    /**
     * Set vAyar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\VaryasyonAyar $vAyar
     * @return \StructType\SaveUrun
     */
    public function setVAyar(\StructType\VaryasyonAyar $vAyar = null)
    {
        if (is_null($vAyar) || (is_array($vAyar) && empty($vAyar))) {
            unset($this->vAyar);
        } else {
            $this->vAyar = $vAyar;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaveUrun
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
