<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TeknikDetayOzellik StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:TeknikDetayOzellik
 * @subpackage Structs
 */
class TeknikDetayOzellik extends AbstractStructBase
{
    /**
     * The GrupID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $GrupID;
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Sira
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Sira;
    /**
     * The Tanim
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tanim;
    /**
     * Constructor method for TeknikDetayOzellik
     * @uses TeknikDetayOzellik::setGrupID()
     * @uses TeknikDetayOzellik::setID()
     * @uses TeknikDetayOzellik::setSira()
     * @uses TeknikDetayOzellik::setTanim()
     * @param int $grupID
     * @param int $iD
     * @param int $sira
     * @param string $tanim
     */
    public function __construct($grupID = null, $iD = null, $sira = null, $tanim = null)
    {
        $this
            ->setGrupID($grupID)
            ->setID($iD)
            ->setSira($sira)
            ->setTanim($tanim);
    }
    /**
     * Get GrupID value
     * @return int|null
     */
    public function getGrupID()
    {
        return $this->GrupID;
    }
    /**
     * Set GrupID value
     * @param int $grupID
     * @return \StructType\TeknikDetayOzellik
     */
    public function setGrupID($grupID = null)
    {
        // validation for constraint: int
        if (!is_null($grupID) && !is_numeric($grupID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($grupID)), __LINE__);
        }
        $this->GrupID = $grupID;
        return $this;
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\TeknikDetayOzellik
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Sira value
     * @return int|null
     */
    public function getSira()
    {
        return $this->Sira;
    }
    /**
     * Set Sira value
     * @param int $sira
     * @return \StructType\TeknikDetayOzellik
     */
    public function setSira($sira = null)
    {
        // validation for constraint: int
        if (!is_null($sira) && !is_numeric($sira)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sira)), __LINE__);
        }
        $this->Sira = $sira;
        return $this;
    }
    /**
     * Get Tanim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTanim()
    {
        return isset($this->Tanim) ? $this->Tanim : null;
    }
    /**
     * Set Tanim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tanim
     * @return \StructType\TeknikDetayOzellik
     */
    public function setTanim($tanim = null)
    {
        // validation for constraint: string
        if (!is_null($tanim) && !is_string($tanim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tanim)), __LINE__);
        }
        if (is_null($tanim) || (is_array($tanim) && empty($tanim))) {
            unset($this->Tanim);
        } else {
            $this->Tanim = $tanim;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TeknikDetayOzellik
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
