<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VaryasyonOzellik StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:VaryasyonOzellik
 * @subpackage Structs
 */
class VaryasyonOzellik extends AbstractStructBase
{
    /**
     * The Deger
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Deger;
    /**
     * The Tanim
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tanim;
    /**
     * The Tur
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Tur;
    /**
     * The XmlKod
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $XmlKod;
    /**
     * Constructor method for VaryasyonOzellik
     * @uses VaryasyonOzellik::setDeger()
     * @uses VaryasyonOzellik::setTanim()
     * @uses VaryasyonOzellik::setTur()
     * @uses VaryasyonOzellik::setXmlKod()
     * @param string $deger
     * @param string $tanim
     * @param string $tur
     * @param string $xmlKod
     */
    public function __construct($deger = null, $tanim = null, $tur = null, $xmlKod = null)
    {
        $this
            ->setDeger($deger)
            ->setTanim($tanim)
            ->setTur($tur)
            ->setXmlKod($xmlKod);
    }
    /**
     * Get Deger value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeger()
    {
        return isset($this->Deger) ? $this->Deger : null;
    }
    /**
     * Set Deger value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deger
     * @return \StructType\VaryasyonOzellik
     */
    public function setDeger($deger = null)
    {
        // validation for constraint: string
        if (!is_null($deger) && !is_string($deger)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deger)), __LINE__);
        }
        if (is_null($deger) || (is_array($deger) && empty($deger))) {
            unset($this->Deger);
        } else {
            $this->Deger = $deger;
        }
        return $this;
    }
    /**
     * Get Tanim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTanim()
    {
        return isset($this->Tanim) ? $this->Tanim : null;
    }
    /**
     * Set Tanim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tanim
     * @return \StructType\VaryasyonOzellik
     */
    public function setTanim($tanim = null)
    {
        // validation for constraint: string
        if (!is_null($tanim) && !is_string($tanim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tanim)), __LINE__);
        }
        if (is_null($tanim) || (is_array($tanim) && empty($tanim))) {
            unset($this->Tanim);
        } else {
            $this->Tanim = $tanim;
        }
        return $this;
    }
    /**
     * Get Tur value
     * @return string|null
     */
    public function getTur()
    {
        return $this->Tur;
    }
    /**
     * Set Tur value
     * @uses \EnumType\BLEnums_VaryasyonTuru::valueIsValid()
     * @uses \EnumType\BLEnums_VaryasyonTuru::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tur
     * @return \StructType\VaryasyonOzellik
     */
    public function setTur($tur = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\BLEnums_VaryasyonTuru::valueIsValid($tur)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $tur, implode(', ', \EnumType\BLEnums_VaryasyonTuru::getValidValues())), __LINE__);
        }
        $this->Tur = $tur;
        return $this;
    }
    /**
     * Get XmlKod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getXmlKod()
    {
        return isset($this->XmlKod) ? $this->XmlKod : null;
    }
    /**
     * Set XmlKod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $xmlKod
     * @return \StructType\VaryasyonOzellik
     */
    public function setXmlKod($xmlKod = null)
    {
        // validation for constraint: string
        if (!is_null($xmlKod) && !is_string($xmlKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($xmlKod)), __LINE__);
        }
        if (is_null($xmlKod) || (is_array($xmlKod) && empty($xmlKod))) {
            unset($this->XmlKod);
        } else {
            $this->XmlKod = $xmlKod;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VaryasyonOzellik
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
